/***************************************************************************/
/*                                                                         */
/*                              KISS Types                                 */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

#ifndef __KISSHDR_H
#define __KISSHDR_H

typedef long int      int32;
typedef short int     int16;
typedef unsigned char byte;

#define KISS_ID 0x5353694b
#define KISS_CEL_MARK 0x20
#define KISS_PAL_MARK 0x10
#define KISS_C32_MARK 0x21

#define PAL_MAX_COLOURS 256

#define KISS_MAX_PALGRP 10

#define CELHDRRESERVED 16

typedef struct __celhdrblock { int32  kissdataid;
                               byte   mark;
                               byte   bpp;
                               int16  reserved1;
                               int16  width;
                               int16  height;
                               int16  x_offset;
                               int16  y_offset;
                               byte   reserved2[CELHDRRESERVED];
                             } KISS_CEL_HEADER;

#define PALHDRRESERVED 20

typedef struct __celdescr { KISS_CEL_HEADER hdr;
                            int             rowsize;
                            int             gs2;
                            byte            **rows;
                          } CEL_DESCRIPTOR;

typedef struct __palhdrblock { int32  kissdataid;
                               byte   mark;
                               byte   bpcol;
                               int16  reserved1;
                               int16  colspergrp;
                               int16  numgroup;
                               byte   reserved2[PALHDRRESERVED];
                             } KISS_PAL_HEADER;

typedef union { int32  word;
                struct { byte red,green, blue, unused;} bytes;
              } paletteword;
#endif
