/***************************************************************************/
/*                                                                         */
/*              Very simply front end to repalette code                    */
/*                                                                         */
/***************************************************************************/

/* CLib */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Application modules */

#include "kisshdr.h"
#include "repalette.h"

static char *helptext[] =
  {
     "repalette <oldcel> <oldkcf> <newkcf> <newcel>",
     NULL
  };

int main(int argc,char **argv)
{
  int status;

  if ( (argc < 2) || (*argv[1] == '?') )
  {
    int loop=0;
    while ( helptext[loop] )
      printf("%s\n",helptext[loop++]);
    exit(0);
  }

  if ( argc < 5 )
  {
    fputs("Missing parameter(s)\n",stderr);
    exit(1);
  }

  status = repalette_ProcessFile(argv[1],argv[2],argv[3],argv[4]);

  switch ( status )
  {
    case REPALETTE_K_OUTOFMEM :
      fputs("Memory allocation failed\n",stderr);
      break;

    case REPALETTE_K_MISMPALETTE :
      fprintf(stderr,"Palette %s does not match cel %s\n",argv[2],argv[1]);
      break;

    case REPALETTE_K_SAVECEL :
      fprintf(stderr,"Failed to save cel %s\n",argv[4]);
      break;

    case REPALETTE_K_NOTCHERRY :
      fprintf(stderr,"Can\'t repalette Cherry cel %s\n",argv[1]);
      break;

    case REPALETTE_K_READCEL :
      fprintf(stderr,"Failed to read cel file %s\n",argv[1]);
      break;

    case REPALETTE_K_READKCF :
      fprintf(stderr,"Failed to read palette file %s\n",argv[2]);
      break;

    case REPALETTE_K_READKCF2 :
      fprintf(stderr,"Failed to read palette file %s\n",argv[3]);
      break;
  }

  return status;
}
